package lecture08.simpsons;

import java.util.Map;
import lecture08.simpsons.places.*;
import lecture08.simpsons.props.*;
import lecture08.simpsons.character.*;
import lecture08.simpsons.visitor.CollectDialog;
import lecture08.simpsons.visitor.CollectDialogReflective;
import lecture08.simpsons.visitor.GameVisitor;
/**
 *
 * @author pavel
 */
public class Simpsons {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Game game = createNewGame();
        CollectDialog collectDialog = new CollectDialog();
        game.acceptVisitor((GameVisitor) collectDialog);
        Map<lecture08.simpsons.character.Character,String> dialog = collectDialog.getDialog();
        
        for(String s : dialog.values()) {
            System.out.println(s);
        }
        
        System.out.println(collectDialog.getDonutCount());
    }
    
    static Game createNewGame() {
        Game g = new Game();
        Place p = new SimpsonsHouse();
        
        Refrigerator r = new Refrigerator();
        r.addProp(new Donut());
        r.addProp(new Donut());
        r.addProp(new Donut());
        r.addProp(new Donut());
        
        r.addProp(new DuffBeer());
        r.addProp(new DuffBeer());
        
        p.addEntity(r);
        
        
        p.addEntity(new Homer());
        p.addEntity(new Homer());
        p.addEntity(new Homer());
        p.addEntity(new Bart());
        p.addEntity(new Apu());
        
        g.addPlace(p);
        return g;
    }
}
